Package: xcoredata
Type: Package
Title: data package for xcore
Version: 1.17.0
Authors@R: 
    c(person(given = "Maciej",
           family = "Migdał",
           role = c("aut", "cre"),
           email = "mcjmigdal@gmail.com",
           comment = c(ORCID = "0000-0002-8021-7263")),
      person(given = "Bogumił",
           family = "Kaczkowski",
           role = c("aut"),
           email = "mcjmigdal@gmail.com",
           comment = c(ORCID = "0000-0001-6554-5608"))
     )
Description: Provides data to use with xcore package.
Depends: R (>= 4.2)
Imports: ExperimentHub (>= 2.2.0), utils (>= 4.2.0)
Suggests: BiocGenerics (>= 0.40.0), data.table (>= 1.14.2),
        GenomeInfoDb (>= 1.30.0), GenomicRanges (>= 1.46.1), IRanges
        (>= 2.28.0), knitr (>= 1.37), rmarkdown (>= 2.11), Matrix (>=
        1.3.4), stringr (>= 1.4.0), S4Vectors (>= 0.32.3),
        TxDb.Hsapiens.UCSC.hg38.knownGene (>= 3.14.0), xcore
License: GPL-2
Encoding: UTF-8
RoxygenNote: 7.1.2
VignetteBuilder: knitr
biocViews: ExperimentHub, ExperimentData, Homo_sapiens_Data
git_url: https://git.bioconductor.org/packages/xcoredata
git_branch: devel
git_last_commit: e4375ad
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.24
Date/Publication: 2026-04-30
NeedsCompilation: no
Packaged: 2026-04-30 16:07:47 UTC; biocbuild
Author: Maciej Migdał [aut, cre] (ORCID:
    <https://orcid.org/0000-0002-8021-7263>),
  Bogumił Kaczkowski [aut] (ORCID:
    <https://orcid.org/0000-0001-6554-5608>)
Maintainer: Maciej Migdał <mcjmigdal@gmail.com>

#!/usr/bin/env R
# Gene symbols to FANTOM5 promoters mapping
load("promoters_f5_core.rda")

symbol2fantom <- setNames(promoters_f5_core$name, promoters_f5_core$SYMBOL)
i_dups <- 
  duplicated(promoters_f5_core$SYMBOL) | duplicated(promoters_f5_core$SYMBOL, fromLast = TRUE)
symbol2fantom <- symbol2fantom[! i_dups]

save(symbol2fantom, file = "symbol2fantom.rda")

#' @importFrom ExperimentHub createHubAccessors
#' @importFrom utils read.csv
#'
.onLoad <- function(libname, pkgname) {
  fl <- system.file("extdata", "metadata.csv", package = pkgname)
  titles <- utils::read.csv(fl, stringsAsFactors=FALSE)$Title
  ExperimentHub::createHubAccessors(pkgname, titles)
}

#!/usr/bin/env R
# Bogumil Kaczkowski
# the purpose of the script is to overlap the FANTOM5 DPI/promoter regions
# with ChipAtlas, Chip-Seq peak data-base
library(xcore)
load("promoters_f5.rda")

# read in the peak into R
chip_atlas_file <- "chip_atlas_hg38.Oth.ALL.05.AllAg.AllCell_SRX_only.bed.gz"
chip_atlas <- rtracklayer::import(chip_atlas_file)
chip_atlas$score <- as.integer(chip_atlas$score)
chip_atlas_meta <-
  read.delim(
    file = "experimentList_TF_hg38.txt",
    sep = "\t",
    header = FALSE,
    quote = "\"")

# remove ambiguous records
ambiguous_tf <- c("5-hmC", "5-mC", "8-Hydroxydeoxyguanosine", "Biotin", "BMI",
                  "BrdU", "Cas9", "Cyclobutane", "MethylCap", "O-GlcNAc",
                  "Pan-acetyllysine", "pFM2", "RTA", "SVS-1", "EBNA1", "EBNA2",
                  "EBNA3", "EBV-ZEBRA", "AML1-ETO", "VSV-G", "MLL-AF4",
                  "MLL-AF6", "Hepatitis", "HIV", "KSHV", "MCPV", "Epitope tags",
                  "GFP", "HIV Tat", "MCPV ST", "KSHV LANA", 
                  "Cyclobutane pyrimidine dimers", "Hepatitis B Virus X antigen")
ambiguous_srx <-
  chip_atlas_meta %>%
  dplyr::filter(V4 %in% ambiguous_tf) %>% # V4 == TF column
  dplyr::pull(V1) # V1 == experiment ID
chip_atlas <- chip_atlas[! chip_atlas$name %in% ambiguous_srx, ]

unique_srxIDs <- unique(chip_atlas$name)
unique_srxIDs <- unique_srxIDs[order(unique_srxIDs)]

# create intersection matrises
chip_atlas_promoters_f5 <-
  xcore::getInteractionMatrix(a = promoters_f5,
                              b = chip_atlas,
                              ext = 500,
                              count = FALSE)
chip_atlas_promoters_f5 <- chip_atlas_promoters_f5[, unique_srxIDs]

# standarize signatures names
data.table::setDT(chip_atlas_meta)
ids <- colnames(chip_atlas_promoters_f5)
data.table::setkey(chip_atlas_meta, V1)
chip_atlas_meta[ids][["V6"]] <- gsub("\\s+", "_", chip_atlas_meta[ids][["V6"]])
chip_atlas_meta[ids][["V6"]] <- gsub("\\.", "_", chip_atlas_meta[ids][["V6"]])

#                                                            tf, background, experiment id
colnames(chip_atlas_promoters_f5) <- chip_atlas_meta[ids, paste(V4, V6, V1, sep = ".")]

# save
save(chip_atlas_promoters_f5, file = "chip_atlas_promoters_f5.rda")

#' Annotate with Nearest Promoter on the Same Strand
#' @param regions query genomic regions as GRanges object
#' @param gencode complete Gencode annotation as GRanges object, e.g. obrained by rtracklayer::import.gff(con = "gencode.v31.annotation.gff3.gz") ,  (gencode[ gencode$type == "transcript"] is also OK)
#' @param cut_off_distance distance in bp used as a cut-off when annotating nearest promoters
#' @return GRanges with new columns added to the feature metadata: mcols(regions)
#' @importFrom GenomicRanges promoters mcols
#' @importFrom S4Vectors DataFrame
#'
gencode_nearest_promoter_same_strand = function( regions, gencode , cut_off_distance = 500) {

	  gencode_promoters   = GenomicRanges::promoters( gencode[ gencode$type == "transcript"] , upstream = 0, downstream = 0, use.names=TRUE)

  regions = gencode_one_direction_distanceToNearest( regions = regions, gencode = gencode_promoters)

    if( !is.null( cut_off_distance )){
	        too_far = regions$nearest_distance > cut_off_distance
      regions$nearest_symbol     [ too_far ]  = ""
          regions$nearest_gene_type  [ too_far ]  = ""
        }

    regions
}

#' Annotation Worker by Same Strand DistanceToNearest
#'
#' @param regions query genomic regions as GRanges object
#' @param gencode Gencode annotation as GRanges object, usually of one type like gencode[ gencode$type == "exon"]
#' @return GRanges with new columns added to the feature metadata: mcols(regions)
#' @importFrom GenomicRanges distanceToNearest
#'
gencode_one_direction_distanceToNearest = function( regions , gencode){

	  # ordering so higher level gene annotation will overwrie lower level annotation
	  # if multiple genes are annotated to same region
	  gencode = gencode[ order( gencode$level , decreasing = F),]

  if( is.null(regions$nearest_symbol) )       { regions$nearest_symbol         = ""}
    if( is.null(regions$nearest_gene_type) )    { regions$nearest_gene_type      = ""}
    if( is.null(regions$nearest_distance) )     { regions$nearest_distance       = -1}

      hits = GenomicRanges::distanceToNearest( regions, gencode , ignore.strand=FALSE)
      regions$nearest_symbol[hits@from]       = gencode$gene_name[hits@to]
        regions$nearest_gene_type[hits@from]    = gencode$gene_type[hits@to]
        regions$nearest_distance                = hits@elementMetadata$distance

	  regions
}

#!/usr/bin/env R
# ChIP-Atlas metadata
library(xcore)
load("chip_atlas_promoters_f5.rda")

# Studies ids fix
srx2srastudy <- data.table::fread("../extdata/srx2study.csv")

chip_atlas_id <- colnames(chip_atlas_promoters_f5)

chip_atlas_meta <- chip_atlas_id %>%
  stringr::str_split(pattern = "\\.", n = 3) %>%
  do.call(what = rbind) %>%
  data.table::as.data.table()
colnames(chip_atlas_meta) <- c("tf", "biotype", "id")

# fix study ids
chip_atlas_meta$study <-
  srx2srastudy[match(chip_atlas_meta$id, srx2srastudy$Experiment), ]$SRAStudy
chip_atlas_meta$study <-
  ifelse(is.na(chip_atlas_meta$study),
         chip_atlas_meta$id,
         chip_atlas_meta$study)

# restore id
chip_atlas_meta$id <- chip_atlas_id

# CIS-BP TF classification
cis_bp <- data.table::fread("cis_bp_tf_class.txt")
cis_bp <-
  cis_bp[, .(tf_dbd = unique(DBDs)),
         by = TF_Name]
data.table::setnames(cis_bp, "TF_Name", "tf")
chip_atlas_meta <- cis_bp[chip_atlas_meta, on = c("tf" = "tf")]

data.table::setcolorder(chip_atlas_meta, c("id", "tf", "tf_dbd", "biotype", "study"))
save(chip_atlas_meta, file = "chip_atlas_meta.rda")

#!/usr/bin/env R

# download source data, some of the data have to be downloaded manually please
# look into download.sh for details
system2("./download.sh")

source("promoters_f5.R")
source("promoters_f5_core.R")
source("remap_promoters_f5.R")
source("remap_meta.R")
source("chip_atlas_promoters_f5.R")
source("chip_atlas_meta.R")

#!/usr/bin/env R
metadata <- data.frame(
  Title = c(
    "chip_atlas_meta",
    "remap_meta",
    "chip_atlas_promoters_f5",
    "remap_promoters_f5",
    "promoters_f5",
    "promoters_f5_core"
  ),
  Description = c(
    "Metadata associated with chip_atlas_promoters_f5",
    "Metadata associated with remap_promoters_f5",
    "An intersection matrix describing overlaps between ChIP-Atlas's ChIP-seq tracks and promoters_f5. To find overlapping regions promoters were extended by 500bp in both directions.",
    "An intersection matrix describing overlaps between ReMap2020's ChIP-seq tracks and promoters_f5. To find overlapping regions promoters were extended by 500bp in both directions.",
    "FANTOM5's hg38 promoters annotated with nearest features in GENCODE ver. 38 annotation and UCSC hg38 knownGene annotation ver. 3.13.0.",
    "Core promoters selected from promoters_f5. Selection criteria were GENCODE confirmation and ENCODE ROADMAP confirmation. Further for each gene single promoter with highest FANTOM5 score was selected."
  ),
  BiocVersion = c("3.15", "3.15", "3.15", "3.15", "3.15", "3.15"),
  Genome = c(NA, NA, "GRCh38", "GRCh38", "GRCh38", "GRCh38"),
  SourceType = c("BED", "BED", "BED", "BED", "BED", "BED"),
  SourceUrl = c(
    "https://www.chip-atlas.org",
    "https://remap.univ-amu.fr/storage/remap2020/hg38/MACS2/remap2020_all_macs2_hg38_v1_0.bed.gz",
    "https://www.chip-atlas.org",
    "https://remap.univ-amu.fr/storage/remap2020/hg38/MACS2/remap2020_all_macs2_hg38_v1_0.bed.gz",
    "https://fantom.gsc.riken.jp/5/datafiles/reprocessed/hg38_v8/extra/CAGE_peaks/hg38_fair+new_CAGE_peaks_phase1and2.bed.gz",
    "https://fantom.gsc.riken.jp/5/datafiles/reprocessed/hg38_v8/extra/CAGE_peaks/hg38_fair+new_CAGE_peaks_phase1and2.bed.gz"
  ),
  SourceVersion = c("7/2021", "ReMap2020", "7/2021", "ReMap2020", "v8", "v8"),
  Species = c(
    NA,
    NA,
    "Homo sapiens",
    "Homo sapiens",
    "Homo sapiens",
    "Homo sapiens"
  ),
  TaxonomyId = c(NA, NA, "9606", "9606", "9606", "9606"),
  Coordinate_1_based = c(NA, NA, NA, NA, TRUE, TRUE),
  DataProvider = c("ChIP-Atlas", "ReMap", "ChIP-Atlas", "ReMap", "RIKEN", "RIKEN"),
  Maintainer = "Maciej Migdal <mcjmigdal@gmail.com>",
  RDataClass = c(
    "data.table",
    "data.table",
    "dgCMatrix",
    "dgCMatrix",
    "GRanges",
    "GRanges"
  ),
  DispatchClass = c("Rda", "Rda", "Rda", "Rda", "Rda", "Rda"),
  RDataPath = paste0(
    "xcoredata/",
    c(
      "chip_atlas_meta.rda",
      "remap_meta.rda",
      "chip_atlas_promoters_f5.rda",
      "remap_promoters_f5.rda",
      "promoters_f5.rda",
      "promoters_f5_core.rda"
    )
  ),
  Tags = NA
)
 
write.csv(
  metadata,
  file = "../extdata/metadata.csv",
  row.names = FALSE
)

#!/usr/bin/env R
# the purpose of the script is to overlap the FANTOM5 DPI/promoter regions with ReMap Chip Seq data-base
library(xcore)
load("promoters_f5.rda")

# read in the peak into R 
remap_input <- "remap2020_all_macs2_hg38_v1_0.bed.gz"
remap <- rtracklayer::import(remap_input)
remap$name <- gsub("\\s+", "", remap$name) # remove white spaces from features names
remap$name <- gsub("__", "_", remap$name)
remap$name <- gsub("--", "", remap$name)


# create intersection matrix
remap_promoters_f5 <-
  xcore::getInteractionMatrix(a = promoters_f5,
                              b = remap,
                              ext = 500,
                              count = FALSE)

# standarize signatures names
srx2srastudy <- data.table::fread("../extdata/srx2study.csv")

translate <- function(x, key, value) {
  newx <- value[match(x, key)]
}

remap_meta <- remap_promoters_f5 %>%
  colnames() %>%
  stringr::str_split(pattern = "\\.", n = 3) %>%
  do.call(what = rbind) %>%
  data.table::as.data.table()
colnames(remap_meta) <- c("id", "tf", "background")

colnames(remap_promoters_f5) <- remap_meta[, paste(tf, background, id, sep = ".")]

# save
save(remap_promoters_f5, file = "remap_promoters_f5.rda")

#!/usr/bin/env R
# ReMap2020 metadata
library(xcore)
load("remap_promoters_f5.rda")

# Studies ids fix
srx2srastudy <- data.table::fread("../extdata/srx2study.csv")

translate <- function(x, key, value) {
  value[match(x, key)]
}

remap_id <- colnames(remap_promoters_f5)

remap_meta <- remap_id %>%
  stringr::str_split(pattern = "\\.", n = 3) %>%
  do.call(what = rbind) %>%
  data.table::as.data.table()
colnames(remap_meta) <- c("tf", "background", "id")
remap_meta$biotype <- remap_meta$background %>%
  gsub(pattern = "_.*", replacement = "")
remap_meta$condition <- remap_meta$background %>%
  sub(pattern = "(.*?)_", replacement = "")
remap_meta$condition[! grepl("_", remap_meta$background)] <- ""
remap_meta[, background := NULL]

# fix study ids
remap_meta$study <- remap_meta$id
remap_meta$study[grepl(pattern = "ENCSR", x = remap_meta$id)] <-
  translate(grep(pattern = "ENCSR", x = remap_meta$id, value = TRUE),
            srx2srastudy$Experiment,
            srx2srastudy$SRAStudy)
remap_meta$study <- ifelse(is.na(remap_meta$study), remap_meta$id, remap_meta$study)

# restore id
remap_meta$id <- remap_id

# CIS-BP TF classification
cis_bp <- data.table::fread("cis_bp_tf_class.txt")
cis_bp <- cis_bp[, .(tf_dbd = unique(DBDs)), by = TF_Name]
data.table::setnames(cis_bp, "TF_Name", "tf")
remap_meta <- cis_bp[remap_meta, on = c("tf" = "tf")]

data.table::setcolorder(remap_meta, c("id", "tf", "tf_dbd", "biotype", "study", "condition"))
save(remap_meta, file = "remap_meta.rda")

#!/usr/bin/env R
# FANTOM5 core promoters
library(xcore)
load("promoters_f5.rda")

dpi2symbol <- promoters_f5 %>%
  S4Vectors::mcols() %>%
  as.data.frame() %>%
  dplyr::filter(! (is.na(SYMBOL) | SYMBOL == "")) %>%
  dplyr::group_by(SYMBOL) %>%
  dplyr::slice(which.max(score)) %>%
  with(., setNames(SYMBOL, name))

# GENCODE confirmation
promoters_f5_core <- 
  promoters_f5[promoters_f5$gene_type_gencode == "protein_coding", ]

# ENCODE ROADMAP confirmation
roadmap_promoters <- rtracklayer::import.bed(con = "Epigenome5DRoadmapDHS_promoter_hg38_liftOver.bed")
GenomeInfoDb::seqlevels(roadmap_promoters, pruning.mode = "coarse") <-
  GenomeInfoDb::seqlevels(promoters_f5_core)
promoters_f5_core <- IRanges::subsetByOverlaps(x = promoters_f5_core, ranges = roadmap_promoters)


# Best promoter per gene based on FANTOM5 score
best_promoters <- GenomicRanges::mcols(promoters_f5_core) %>%
  as.data.frame() %>%
  dplyr::group_by(SYMBOL) %>%
  dplyr::slice(which.max(score)) %>%
  dplyr::pull(name)
promoters_f5_core <-
  promoters_f5_core[promoters_f5_core$name %in% best_promoters, ]

save(promoters_f5_core, file = "promoters_f5_core.rda")

#!/usr/bin/env R
# A script to Annotate the FANTOM5 promoters/TSS regions
# getting BED files from FANTOM5 website one for the coordinates (bed) and one with official annotation
library(xcore)
source("utils.R")

dpi_bed_file  <- "hg38_fair+new_CAGE_peaks_phase1and2.bed.gz"
dpi_annot_file <- "hg38_fair+new_CAGE_peaks_phase1and2_ann.txt.gz"

dpi <- rtracklayer::import.bed(dpi_bed_file)
dpi$itemRgb <- NULL
dpi$thick <- NULL
dpi <- dpi[order(dpi$name), ]

seqinfo_hg38 <- rtracklayer::SeqinfoForUCSCGenome("hg38")
seqinfo_hg38 <- seqinfo_hg38[
  names(seqinfo_hg38) [names(seqinfo_hg38) %in% seqnames(dpi)]
  ]
seqinfo_hg38 <- seqinfo_hg38[names(seqinfo_hg38)[c(1:22, 25, 23, 24)]]

seqinfo(dpi) <- seqinfo_hg38

dpi_annot <- data.table::fread(dpi_annot_file, header = TRUE, sep = "\t")
data.table::setDF(dpi_annot)
dpi_annot <- dpi_annot[dpi_annot$`00Annotation` %in% dpi$name, ]
dpi_annot <- dpi_annot[order(dpi_annot$`00Annotation`), ]

table(dpi_annot$`00Annotation` == dpi$name)
# TRUE
# 209911

# This is how example dpi_annot line looks like
# 00Annotation    short_description       description     association_with_transcript     entrezgene_id   hgnc_id uniprot_id
# hg19::chr1:564571..564600,+;hg_1.1      p1@MTND1P23     CAGE_peak_1_at_MTND1P23_5end    -130bp_to_ENST00000416931.1_5end        NA      HGNC:42092      NA
# hg19::chr1:840185..840202,+;hg_20.1     hg_20.1 CAGE_peak_hg_20.1       12bp_to_ENST00000607769.1,uc057axn.1_5end       NA      NA      NA
dpi$SYMBOL_F5_annot <- gsub("\\.*", "", gsub(".*@", "", dpi_annot$short_description)) # sub(" .*", "", dpi_annot$Gene_symbol)
# in $short_description we have a lot of hg_1234... which are not symbols acctually
dpi$SYMBOL_F5_annot <- gsub("hg_[0-9]+", "", dpi$SYMBOL_F5_annot)
dpi$ENTREZID_F5_annot <- sub(" .*", "", dpi_annot$entrezgene_id)
dpi$ENTREZID_F5_annot[is.na(dpi$ENTREZID_F5_annot)] <- ""
dpi$distance_F5_annot <- as.integer(gsub("bp_to_.*", "", dpi_annot$association_with_transcript)) # dpi_annot$Distance
dpi$distance_F5_annot[is.na(dpi$distance_F5_annot)] <- ""

# GENCODE 38 annotation
gencode_file <- "gencode.v38.annotation.gff3.gz"
gencode <- rtracklayer::import.gff(con = gencode_file)
dpi_gencode <- gencode_nearest_promoter_same_strand(regions = dpi,
		 				    gencode = gencode,
	 					    cut_off_distance = 500)
dpi$SYMBOL_gencode <- dpi_gencode$nearest_symbol
select_first <- function(x) { x[1] }
dpi$ENTREZID_gencode <- as.character(lapply(
  X = AnnotationDbi::mapIds(
    x = org.Hs.eg.db::org.Hs.eg.db,
    keys = dpi$SYMBOL_gencode,
    column = 'ENTREZID',
    keytype = 'SYMBOL'),
  FUN = select_first))
dpi$ENTREZID_gencode[dpi$ENTREZID_gencode == "NULL"] <- ""
dpi$ENTREZID_gencode[is.na(dpi$ENTREZID_gencode)] <- ""
dpi$gene_type_gencode <- as.factor(dpi_gencode$nearest_gene_type)
dpi$distance_gencode <- dpi_gencode$nearest_distance

# UCSC.hg38.knownGene annotation
ucsc_knownGene <-
  GenomicFeatures::asGFF(TxDb.Hsapiens.UCSC.hg38.knownGene::TxDb.Hsapiens.UCSC.hg38.knownGene)
ucsc_knownGene <- ucsc_knownGene[ucsc_knownGene$type == "mRNA"]
ucsc_knownGene_promoters <- GenomicRanges::promoters(ucsc_knownGene, upstream = 0, downstream = 0, use.names=TRUE)
ucsc_knownGene_promoters$Parent <- drop(ucsc_knownGene_promoters$Parent)
ucsc_knownGene_promoters <- ucsc_knownGene_promoters [! is.na(ucsc_knownGene_promoters$Parent)]
ucsc_knownGene_promoters$Parent <- sub("GeneID:", "", ucsc_knownGene_promoters$Parent)

dpi$SYMBOL_ucsc <- ""
dpi$ENTREZID_ucsc <- ""
dpi$distance_ucsc <- 10^6

hits <- GenomicRanges::distanceToNearest(dpi, ucsc_knownGene_promoters, ignore.strand=FALSE)
dpi$ENTREZID_ucsc[hits@from] <- ucsc_knownGene_promoters$Parent[hits@to]
dpi$distance_ucsc[hits@from] <- hits@elementMetadata$distance
select_first <- function(x) { x[1] }
dpi$SYMBOL_ucsc  = as.character(lapply(
  X = AnnotationDbi::mapIds(
    x = org.Hs.eg.db::org.Hs.eg.db,
    keys = dpi$ENTREZID_ucsc,
    column = 'SYMBOL',
    keytype = 'ENTREZID'),
  FUN = select_first))
dpi$SYMBOL_ucsc[dpi$SYMBOL_ucsc == "NULL"] <- ""
dpi$SYMBOL_ucsc[is.na(dpi$SYMBOL_ucsc)] <- ""

too_far <- dpi$distance_ucsc > 500
dpi$ENTREZID_ucsc[too_far] <- ""
dpi$SYMBOL_ucsc[too_far] <- ""

# simplifying/collapsing ENTREZID
dpi$ENTREZID <- dpi$ENTREZID_ucsc
empty <- dpi$ENTREZID == ""
dpi$ENTREZID[empty] <- dpi$ENTREZID_gencode[empty]
empty <- dpi$ENTREZID == ""
dpi$ENTREZID[empty] <- dpi$ENTREZID_F5_annot[empty]

# simplifying/collapsing SYMBOLs
dpi$SYMBOL <- dpi$SYMBOL_ucsc
empty <- dpi$SYMBOL == ""
dpi$SYMBOL[empty] <- dpi$SYMBOL_gencode[empty]
empty <- dpi$SYMBOL == ""
dpi$SYMBOL[empty] <- dpi$SYMBOL_F5_annot[empty]

# some check, stats and overview
s <- dpi$SYMBOL_F5_annot != ""
table(dpi$SYMBOL_F5_annot[s] == dpi$SYMBOL[s]) # the FALSE should be about 1.8%, not 15%!!!!
# FALSE  TRUE
#  3305 96576
# FALSE = 3.3089%
s <- dpi$ENTREZID_F5_annot != ""
table(dpi$ENTREZID_F5_annot[s] == dpi$ENTREZID[s]) # the FALSE should be below 1%
# FALSE  TRUE
#   969 96786
# FALSE = 0.99125%

promoters_f5 <- dpi

# drop unneeded metadata
promoters_f5$distance_F5_annot <- NULL
promoters_f5$distance_gencode <- NULL
promoters_f5$distance_ucsc <- NULL
promoters_f5$SYMBOL_F5_annot <- NULL
promoters_f5$ENTREZID_F5_annot <- NULL
promoters_f5$SYMBOL_gencode <- NULL
promoters_f5$ENTREZID_gencode <- NULL
promoters_f5$SYMBOL_ucsc <- NULL
promoters_f5$ENTREZID_ucsc <- NULL

save(promoters_f5, file = "promoters_f5.rda")

#' Promoters GenomicRanges object
#'
#' FANTOM5's hg38 promoters annotated with nearest features in GENCODE ver.
#' 38 annotation and UCSC hg38 knownGene annotation ver. 3.13.0.
#'
#' @format A \code{GenomicRanges} object of length 209911, with 11 metadata columns:
#' \describe{
#'   \item{name}{Promotor name.}
#'   \item{score}{Numeric vector.}
#'   \item{gene_type_gencode}{Gene type of associated gene as defined by GENCODE annotation.}
#'   \item{ENTREZID}{ENTREZ ID of associated gene as defined by all three annotation sources.
#'                   Prevalence of annotations: UCSC > GENCODE > FANTOM5.}
#'   \item{SYMBOL}{Gene symbol of associated gene as defined by all three annotation sources.
#'                 Prevalence of annotations: UCSC > GENCODE > FANTOM5.}
#' }
#'
#' @examples
#' promoters_f5()
#'
"promoters_f5"

#' Core promoters GenomicRanges object
#'
#' Core promoters selected from promoters_f5.
#' Selection criteria were GENCODE confirmation and ENCODE ROADMAP confirmation.
#' Further for each gene single promoter with highest FANTOM5 score was selected.
#'
#' @format A \code{GenomicRanges} object of length 14191, with 16 metadata columns:
#' \describe{
#'   \item{name}{Promotor name.}
#'   \item{score}{Numeric vector.}
#'   \item{gene_type_gencode}{Gene type of associated gene as defined by GENCODE annotation.}
#'   \item{ENTREZID}{ENTREZ ID of associated gene as defined by all three annotation sources.
#'                   Prevalence of annotations: UCSC > GENCODE > FANTOM5.}
#'   \item{SYMBOL}{Gene symbol of associated gene as defined by all three annotation sources.
#'                 Prevalence of annotations: UCSC > GENCODE > FANTOM5.}
#' }
#'
#' @examples
#' promoters_f5_core()
#'
"promoters_f5_core"

#' ReMap2020 and FANTOM5 promoters intersection matrix
#'
#' An intersection matrix describing overlaps between ReMap2020's ChIP-seq tracks
#' and \code{\link{promoters_f5}}. To find overlapping regions promoters were extended
#' by 500bp in both directions.
#'
#' @format A Matrix with 209911 rows and 5728 columns. Row names corresponds to promoters
#'         names, column names are formatted as ExperimentID.TranscriptionFactor.Biotype.
#'
#' @examples
#' remap_promoters_f5()
#'
"remap_promoters_f5"

#' ChIP-Atlas FANTOM5 promoters intersection matrix
#'
#' An intersection matrix describing overlaps between ChIP-Atlas's ChIP-seq tracks
#' and \code{\link{promoters_f5}}. To find overlapping regions promoters were extended
#' by 500bp in both directions.
#'
#' @format A \code{Matrix} with 209911 rows and 13891 columns. Row names corresponds to promoters
#'         names, column names are formatted as TranscriptionFactor_Origin_Cell_ExperimentID
#'	   (eg. PARK7_Neural_SH-SY5Y_DRX000550, MLL-AF6_Blood_ML-2_DRX001460).
#'
#' @examples
#' chip_atlas_promoters_f5()
#'
"chip_atlas_promoters_f5"

#' ReMap2020 metadata
#'
#' Metadata associated with \code{remap_promoters}.
#'
#' @format A \code{data.table} with 5798 rows and 6 columns.
#' \describe{
#'   \item{id}{Character giving internal experiment ID.}
#'   \item{tf}{Character giving transcription factor name.}
#'   \item{tf_dbd}{Character giving transcription factor DNA binding domain
#'                 family, as per CIS BP database.}
#'   \item{biotype}{Character giving experiment biological origin.}
#'   \item{study}{Character giving study ID.}
#'   \item{condition}{Character specifiying experiment conditions or treatment.}
#' }
#'
#' @examples
#' remap_meta()
#'
"remap_meta"

#' ChIP-Atlas metadata
#'
#' Metadata associated with \code{chip_atlas_promoters}.
#'
#' @format A \code{data.frame} with 13891 rows and 5 columns.
#' \describe{
#'   \item{id}{Character giving internal experiment ID.}
#'   \item{tf}{Character giving transcription factor name.}
#'   \item{tf_dbd}{Character giving transcription factor DNA binding domain
#'                 family, as per CIS BP database.}
#'   \item{biotype}{Character giving experiment biological origin.}
#'   \item{study}{Character giving study ID.}
#' }
#'
#' @examples
#' chip_atlas_meta()
#'
"chip_atlas_meta"

#' ENTREZ IDs to FANTOM5 core promoters names mappings
#'
#' Vector mapping ENTREZ IDs to FANTOM5 core promoters names.
#'
#' @format A named \code{character} vector of length 14214.
#'
#' @examples
#' entrez2fantom()
#'
"entrez2fantom"

#' Gene symbols to FANTOM5 core promoters names mappings
#'
#' Vector mapping gene symbols to FANTOM5 core promoters names.
#'
#' @format A named \code{character} vector of length 14222.
#'
#' @examples
#' symbol2fantom()
#'
"symbol2fantom"

#!/usr/bin/env R
# ENTREZ IDs to FANTOM5 promoters mapping
load("promoters_f5_core.rda")

entrez2fantom <- setNames(promoters_f5_core$name, promoters_f5_core$ENTREZID)
i_dups <- 
  duplicated(promoters_f5_core$ENTREZID) | duplicated(promoters_f5_core$ENTREZID, fromLast = TRUE)
entrez2fantom <- entrez2fantom[! i_dups]

save(entrez2fantom, file = "entrez2fantom.rda")

#!/usr/bin/bash
# Download external dataset including ReMap peaks.
# Caution! CIS-BP classification has to be downloaded manually

## Check if the dataset, given as the URL, has been already downloaded and download it if it has not.
function downloadDataset {
  dataset=`basename $1`
  if [ ! -f ${dataset} ]; then
    wget $1
  fi
}

# Download ChIP-Atlas
# hg38 TFs and others (15217) in All cell types (61679) with 50 Threshold for Significance
downloadDataset http://dbarchive.biosciencedbc.jp/kyushu-u/hg38/assembled/Oth.ALL.05.AllAg.AllCell.bed
# process ChIP-Atlas data to extract SRX field and remove unncecessary data from 4th column
if [ ! -f chip_atlas_hg38.Oth.ALL.05.AllAg.AllCell_SRX_only.bed.gz ]; then
  cat Oth.ALL.05.AllAg.AllCell.bed | \
    awk '{gsub(";.*|ID=","",$4)}1' |  \
    awk 'OFS="\t" {print $1,$2,$3,$4,$5,$6}' | \
    tail -n +2 | \
    gzip > chip_atlas_hg38.Oth.ALL.05.AllAg.AllCell_SRX_only.bed.gz
fi
# download experiments metadata
downloadDataset http://dbarchive.biosciencedbc.jp/kyushu-u/metadata/experimentList.tab
if [ ! -f experimentList_TF_hg38.txt ]; then
  grep -w hg38 experimentList.tab | grep -w 'TFs and others' | awk '{if($2 == "hg38"){print $0}}' > experimentList_TF_hg38.txt
fi

# CIS-BP classification
# has to be downloaded manually from http://cisbp.ccbr.utoronto.ca/bulk.php, 
# select By Species: Homo_sapiens and TF info

# Epigenome5DRoadmapDHS_promoter_hg38_liftOver.bed TODO

# Download GENCODE annotation
downloadDataset http://ftp.ebi.ac.uk/pub/databases/gencode/Gencode_human/release_38/gencode.v38.annotation.gff3.gz

# Download FANTOM5 annotations
# promoters bed hg38
downloadDataset https://fantom.gsc.riken.jp/5/datafiles/reprocessed/hg38_v8/extra/CAGE_peaks/hg38_fair+new_CAGE_peaks_phase1and2.bed.gz
# promoters annotation hg38
downloadDataset https://fantom.gsc.riken.jp/5/datafiles/reprocessed/hg38_v8/extra/CAGE_peaks_expression/hg38_fair+new_CAGE_peaks_phase1and2_ann.txt.gz
# CAGE peaks (promoters) counts tables
downloadDataset https://fantom.gsc.riken.jp/5/datafiles/reprocessed/hg38_v8/extra/CAGE_peaks_expression/hg38_fair+new_CAGE_peaks_phase1and2_counts_ann.osc.txt.gz

# Download ReMap
# all peaks hg38
downloadDataset https://remap.univ-amu.fr/storage/remap2020/hg38/MACS2/remap2020_all_macs2_hg38_v1_0.bed.gz
# merged (non redundant) peaks hg38
downloadDataset https://remap.univ-amu.fr/storage/remap2020/hg38/MACS2/remap2020_nr_macs2_hg38_v1_0.bed.gz

---
title: "xcoredata"
author: "Maciej Migdał"
date: "`r Sys.Date()`"
output: html_vignette
vignette: >
  %\VignetteIndexEntry{xcoredata}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r setup, include = FALSE}
knitr::opts_chunk$set(collapse = TRUE)
```

# Exploring the data in xcoredata

```{r}
library("xcoredata")
```

`xcoredata` contains the following objects, which can be accessed directly with
named functions:

```{r}
# FANTOM5 promoters
promoters_f5()
promoters_f5_core()

# ReMap2020 molecular signatures
remap_promoters_f5()
remap_meta()

# ChIP-Atlas molecular signatures
chip_atlas_promoters_f5()
chip_atlas_meta()
```

Alternatively, these objects can be accessed using the *ExperimentHub* interface,
eg.:

```{r}
library("ExperimentHub")

eh <- ExperimentHub()
query(eh, "remap_meta")
eh[["EH7299"]]
```

For details on these resources see object's documentation eg. `?remap_meta`.
The construction scripts are located under `inst/scripts`, especially look
into `inst/scripts/make-data.Rmd`.

```{r}
sessionInfo()
```

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{promoters_f5_core}
\alias{promoters_f5_core}
\title{Core promoters GenomicRanges object}
\format{
A \code{GenomicRanges} object of length 14191, with 16 metadata columns:
\describe{
  \item{name}{Promotor name.}
  \item{score}{Numeric vector.}
  \item{gene_type_gencode}{Gene type of associated gene as defined by GENCODE annotation.}
  \item{ENTREZID}{ENTREZ ID of associated gene as defined by all three annotation sources.
                  Prevalence of annotations: UCSC > GENCODE > FANTOM5.}
  \item{SYMBOL}{Gene symbol of associated gene as defined by all three annotation sources.
                Prevalence of annotations: UCSC > GENCODE > FANTOM5.}
}
}
\usage{
promoters_f5_core
}
\description{
Core promoters selected from promoters_f5.
Selection criteria were GENCODE confirmation and ENCODE ROADMAP confirmation.
Further for each gene single promoter with highest FANTOM5 score was selected.
}
\examples{
promoters_f5_core()

}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{promoters_f5}
\alias{promoters_f5}
\title{Promoters GenomicRanges object}
\format{
A \code{GenomicRanges} object of length 209911, with 11 metadata columns:
\describe{
  \item{name}{Promotor name.}
  \item{score}{Numeric vector.}
  \item{gene_type_gencode}{Gene type of associated gene as defined by GENCODE annotation.}
  \item{ENTREZID}{ENTREZ ID of associated gene as defined by all three annotation sources.
                  Prevalence of annotations: UCSC > GENCODE > FANTOM5.}
  \item{SYMBOL}{Gene symbol of associated gene as defined by all three annotation sources.
                Prevalence of annotations: UCSC > GENCODE > FANTOM5.}
}
}
\usage{
promoters_f5
}
\description{
FANTOM5's hg38 promoters annotated with nearest features in GENCODE ver.
38 annotation and UCSC hg38 knownGene annotation ver. 3.13.0.
}
\examples{
promoters_f5()

}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{entrez2fantom}
\alias{entrez2fantom}
\title{ENTREZ IDs to FANTOM5 core promoters names mappings}
\format{
A named \code{character} vector of length 14214.
}
\usage{
entrez2fantom
}
\description{
Vector mapping ENTREZ IDs to FANTOM5 core promoters names.
}
\examples{
entrez2fantom()

}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{symbol2fantom}
\alias{symbol2fantom}
\title{Gene symbols to FANTOM5 core promoters names mappings}
\format{
A named \code{character} vector of length 14222.
}
\usage{
symbol2fantom
}
\description{
Vector mapping gene symbols to FANTOM5 core promoters names.
}
\examples{
symbol2fantom()

}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{remap_meta}
\alias{remap_meta}
\title{ReMap2020 metadata}
\format{
A \code{data.table} with 5798 rows and 6 columns.
\describe{
  \item{id}{Character giving internal experiment ID.}
  \item{tf}{Character giving transcription factor name.}
  \item{tf_dbd}{Character giving transcription factor DNA binding domain
                family, as per CIS BP database.}
  \item{biotype}{Character giving experiment biological origin.}
  \item{study}{Character giving study ID.}
  \item{condition}{Character specifiying experiment conditions or treatment.}
}
}
\usage{
remap_meta
}
\description{
Metadata associated with \code{remap_promoters}.
}
\examples{
remap_meta()

}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{chip_atlas_promoters_f5}
\alias{chip_atlas_promoters_f5}
\title{ChIP-Atlas FANTOM5 promoters intersection matrix}
\format{
A \code{Matrix} with 209911 rows and 13891 columns. Row names corresponds to promoters
        names, column names are formatted as TranscriptionFactor_Origin_Cell_ExperimentID
   (eg. PARK7_Neural_SH-SY5Y_DRX000550, MLL-AF6_Blood_ML-2_DRX001460).
}
\usage{
chip_atlas_promoters_f5
}
\description{
An intersection matrix describing overlaps between ChIP-Atlas's ChIP-seq tracks
and \code{\link{promoters_f5}}. To find overlapping regions promoters were extended
by 500bp in both directions.
}
\examples{
chip_atlas_promoters_f5()

}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{remap_promoters_f5}
\alias{remap_promoters_f5}
\title{ReMap2020 and FANTOM5 promoters intersection matrix}
\format{
A Matrix with 209911 rows and 5728 columns. Row names corresponds to promoters
        names, column names are formatted as ExperimentID.TranscriptionFactor.Biotype.
}
\usage{
remap_promoters_f5
}
\description{
An intersection matrix describing overlaps between ReMap2020's ChIP-seq tracks
and \code{\link{promoters_f5}}. To find overlapping regions promoters were extended
by 500bp in both directions.
}
\examples{
remap_promoters_f5()

}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{chip_atlas_meta}
\alias{chip_atlas_meta}
\title{ChIP-Atlas metadata}
\format{
A \code{data.frame} with 13891 rows and 5 columns.
\describe{
  \item{id}{Character giving internal experiment ID.}
  \item{tf}{Character giving transcription factor name.}
  \item{tf_dbd}{Character giving transcription factor DNA binding domain
                family, as per CIS BP database.}
  \item{biotype}{Character giving experiment biological origin.}
  \item{study}{Character giving study ID.}
}
}
\usage{
chip_atlas_meta
}
\description{
Metadata associated with \code{chip_atlas_promoters}.
}
\examples{
chip_atlas_meta()

}
\keyword{datasets}
